<html devsite>
  <head>
    <title>Audio Loopback Dongle</title>
    <meta name="project_path" value="/_project.yaml" />
    <meta name="book_path" value="/_book.yaml" />
  </head>
  <body>
  <!--
      Copyright 2017 The Android Open Source Project

      Licensed under the Apache License, Version 2.0 (the "License");
      you may not use this file except in compliance with the License.
      You may obtain a copy of the License at

          http://www.apache.org/licenses/LICENSE-2.0

      Unless required by applicable law or agreed to in writing, software
      distributed under the License is distributed on an "AS IS" BASIS,
      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
      See the License for the specific language governing permissions and
      limitations under the License.
  -->



<p>
The diagram and photo below show an audio loopback
<a href="http://en.wikipedia.org/wiki/Dongle">dongle</a>
for the
<a href="http://en.wikipedia.org/wiki/Phone_connector_(audio)">headset connector</a>
that we call the "Dr. Rick O'Rang audio loopback dongle."
The Chrome hardware team designed this circuit and plug for functional testing;
however it has many other uses too.  The Android audio team uses it to measure
<a href="measure.html#measuringRoundTrip">round-trip audio latency</a>,
via the Larsen effect (feedback loop).
</p>

<h2 id="loopbackCircuit">Circuit</h2>

<img src="/devices/audio/images/loopback_circuit.png" alt="circuit" id="figure1" />
<p class="img-caption">
  <strong>Figure 1.</strong> circuit diagram
</p>

<p>
To ensure that the output signal will not overload the microphone input,
we cut it down by about 20dB.
The resistor loads tell the microphone polarity switch that
the audio loopback dongle is a US/CTIA pinout Tip Ring Ring Shield (TRRS) plug.
</p>

<h2 id="loopbackAssembled">Assembled</h2>

<img src="/devices/audio/images/loopback_assembled.jpg" alt="fully assembled" id="figure2" />
<p class="img-caption">
  <strong>Figure 2.</strong> Assembled
</p>

  </body>
</html>
